/* JOYBITS2.C ---- Polls and displays bits of port 201h.
 * by Gary Neal, Jr. -- garyneal@geocities.com
 */

#include <conio.h>  /* Console specific I/O */
#include <graph.h>

int main(void)
{
    int joyState, bitMask;

    _clearscreen(_GCLEARSCREEN);     /* Blank the screen */
    _displaycursor(_GCURSOROFF);     /* Specific to MS C, okay to delete */
    _settextposition(7, 10);         /* Set screen position */
    _cputs("Port 201h status bits:");
    _settextposition(9, 15);         /* Set screen position */
    _cputs("7 6 5 4 3 2 1 0");
    _settextposition(13, 15);        /* Set screen position */
    _cputs("^ ^ ^ ^ ^ ^ ^ ^");
    _settextposition(14, 15);        /* Set screen position */
    _cputs("| | | | | | | +--- Capacitor state for Joystick A X-axis");
    _settextposition(15, 15);        /* Set screen position */
    _cputs("| | | | | | +----- Capacitor state for Joystick A Y-axis");
    _settextposition(16, 15);        /* Set screen position */
    _cputs("| | | | | +------- Capacitor state for Joystick B X-axis");
    _settextposition(17, 15);        /* Set screen position */
    _cputs("| | | | +--------- Capacitor state for Joystick B Y-axis");
    _settextposition(18, 15);        /* Set screen position */
    _cputs("| | | +----------- Switch state for Joystick A Button 1");
    _settextposition(19, 15);        /* Set screen position */
    _cputs("| | +------------- Switch state for Joystick A Button 2");
    _settextposition(20, 15);        /* Set screen position */
    _cputs("| +--------------- Switch state for Joystick B Button 1");
    _settextposition(21, 15);        /* Set screen position */
    _cputs("+----------------- Switch state for Joystick B Button 2");

    while (_kbhit()) _getch();       /* Clear the keyboard */

    while (!_kbhit()) {
        joyState = _inp(0x201);      /* Read the joystick port */
        _settextposition(11, 15);    /* Screen position for bits */
        for (bitMask = 0x80; bitMask; bitMask >>= 1) {
            if (joyState & bitMask)  /* Mask bit and display it */
                _putch('1');
            else
                _putch('0');
            _putch(' ');
        }
    }

    while (_kbhit()) _getch();    /* Clear the keyboard */
    _displaycursor(_GCURSORON);   /* Restore the cursor */
    return 0;
}
