/* JOYPOTS.C -- Samples joystick pots and retreives their values.
 * by Gary Neal, Jr. -- garyneal@geocities.com
 */

#include <conio.h>                       /* Console specific I/O */
#include <graph.h>

int main(void)
{
    unsigned int joyState;               /* Bit status of Port 201h */
    unsigned short joyPotVal[4], limit;  /* Loop counters & counting limit */

    _clearscreen(_GCLEARSCREEN);         /* Clear the screen */
    _settextposition(9, 10);             /* Set screen position */
    _cputs("Joystick potentiometer values:");

    /* Initialize loop counters */
    joyPotVal[0] = joyPotVal[1] = joyPotVal[2] = joyPotVal[3] = limit = 0;

    _outp(0x201, 0);                     /* Discharge capacitors */

    do {
        joyState = _inp(0x201);          /* Get capacitor status bits */

        /* Increase pot value count until cap fully charges */
        joyPotVal[0] += ((joyState & 0x01) != 0);
        joyPotVal[1] += ((joyState & 0x02) != 0);
        joyPotVal[2] += ((joyState & 0x04) != 0);
        joyPotVal[3] += ((joyState & 0x08) != 0);

        /* Increase loop limit count */
        limit += 1;

        /* Continue until all caps are fully charged or limit is reached */
    } while ((joyState & 0x0F) && limit);

    /* Write joystick pot values on screen */
    _settextposition(11, 15);
    _cprintf("Joystick A's X-axis = %u", joyPotVal[0]);
    _settextposition(12, 15);
    _cprintf("Joystick A's Y-axis = %u", joyPotVal[1]);
    _settextposition(13, 15);
    _cprintf("Joystick B's X-axis = %u", joyPotVal[2]);
    _settextposition(14, 15);
    _cprintf("Joystick B's Y-axis = %u", joyPotVal[3]);

    return 0;
}
