/* JOYVALS.C -- Reads the joystick status values.
 * by Gary Neal, Jr. -- garyneal@geocities.com
 */

#include "..\include\joystick.h"   /* Joystick functions */
#include <conio.h>                 /* Console specific IO */
#include <graph.h>

int main(int argc, char *argv[])
{
    unsigned char testButton;

    /* Get argument and set access flag accordingly */
    if (argc > 1 && argv[1][0] == '1')
        joystickDirectAccess = 1;  /* User typed 'JOYVALS 1' at DOS prompt */
    else
        joystickDirectAccess = 0;  /* User typed 'JOYVALS' at DOS prompt */

    Joyin(1);                      /* Test for joystick pot availability */
    if (!(joyPotVal[0] || joyPotVal[1])) {
        _cputs("No joystick connected...\r\n\r\nAborting!!!");
        return 1;                  /* Quit if no joysticks found */
    }

    _displaycursor(_GCURSOROFF);   /* Remove cursor from display */

    while(_kbhit()) _getch();      /* Clear the keyboard */
    _clearscreen(_GCLEARSCREEN);   /* Clear the screen */

    while(!kbhit()) {
        Joyin(0);                  /* Get joystick pots */
        _settextposition(1, 1);    /* Set cursor position */
        _cprintf("Joystick A - X Axis = %d  \r\n"
                 "Joystick A - Y Axis = %d  \r\n"
                 "Joystick B - X Axis = %d  \r\n"
                 "Joystick B - Y Axis = %d  \r\n\r\n",
                 joyPotVal[JsA_Xaxis],
                 joyPotVal[JsA_Yaxis],
                 joyPotVal[JsB_Xaxis],
                 joyPotVal[JsB_Yaxis]);

        /* Get button status */
        testButton = JoystickButtonPressed(JsAllButtons);

        /* Write status of button one on Joystick A */
        if (testButton & JsAbutton1)
            _cputs("Button 1 on Joystick A pressed.\r\n");
        else
            _cputs("                               \r\n");

        /* Write status of button two on Joystick A */
        if (testButton & JsAbutton2)
            _cputs("Button 2 on Joystick A pressed.\r\n");
        else
            _cputs("                               \r\n");

        /* Write status of button one on Joystick B */
        if (testButton & JsBbutton1)
            _cputs("Button 1 on Joystick B pressed.\r\n");
        else
            _cputs("                               \r\n");

        /* Write status of button two on Joystick B */
        if (testButton & JsBbutton2)
            _cputs("Button 2 on Joystick B pressed.\r\n");
        else
            _cputs("                               \r\n");
    }

    while(_kbhit()) _getch();      /* Clear the keyboard */
    _clearscreen(_GCLEARSCREEN);   /* Clear the screen */
    _displaycursor(_GCURSORON);    /* Restore cursor display */
    return 0;
}
