/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * HELLOPAL.C -- Hello Palette World!                                      *
 *                                                                         *
 * A little twist on the old, worn-out Hello World application.            *
 * Demonstrates the changing of colors via the VGA palette.                *
 *                                                                         *
 * by Gary Neal, Jr. -- garyneal@geocities.com                             *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <dos.h>                   /* Needed for the delay function */
#include <conio.h>                 /* Console specific I-O */
#include <stdlib.h>                /* Needed for rand() function */
#include <graph.h>
#include "..\include\vmode.h"      /* Our video mode functions */
#include "..\include\palette.h"    /* Palette functions */

void Delay(int clicks);

int main(void)
{
    union ColorAttribute color;    /* Declare a color variable */

    /* Put the screen into Mode 13H */
    if (!SetVideoMode(VGA256)) {
        _cputs("Failed to initialize VGA video mode.\r\nAborting...\r\n");
        return 1;
    }

    _settextposition(9, 10);
    _cputs("Hello Palette World!");
    _settextposition(13, 2);
    _cputs("Press a key and watch me change colors");

    while (_kbhit()) _getch();     /* Clear the keyboard */
    while (!_kbhit());             /* Wait for a key */

    _settextposition(17, 6);
    _cputs("Press a key to end this demo");

    while (_kbhit()) _getch();     /* Clear the keyboard */
    while (!_kbhit()) {            /* Wait for a key */
        color.RGB.red   = (rand() % 64);
        color.RGB.green = (rand() % 64);
        color.RGB.blue  = (rand() % 64);
        SetPalette(7, color);
        Delay(2);
    }

    while (_kbhit()) _getch();     /* Clear the keyboard */
    SetVideoMode(TEXT_MODE);       /* Return to text mode */
    return 0;
}

void Delay(int clicks)
{
// this function uses the internal time keeper timer i.e. the one that goes
// at 18.2 clicks/sec to to a time delay.  You can find a 32 bit value of
// this timer at 0000:046Ch

unsigned int far *clock = (unsigned int far *)0x0000046CL;

unsigned int now;

// get current time

now = *clock;

// wait till time has gone past current time plus the amount we eanted to
// wait.  Note each click is approx. 55 milliseconds.

while(abs(*clock - now) < clicks){}

} // end Delay

