/* PIXELS.C -- by Gary N Wilkerson Jr.
 *
 * Demonstrates the usage of the SetVideoMode
 * and the SetPixel functions.
 */

#include <stdlib.h>  /* Required for rand() functions   */
#include <dos.h>     /* Required for int86() functions  */
#include <conio.h>   /* Required for keyboard functions */

/* Video display definitions */
#define TEXT_MODE 0x03
#define VGA256    0x13

/* Function prototypes */
void SetVideoMode(short int mode);
void SetPixel(short int X, short int Y, unsigned char C);

/* Create a pointer to video memory */
unsigned char far *videoMem = (unsigned char far *)0xA0000000L;

/* Our main program */
short int main(void)
{
     while (_kbhit()) _getch();/* Clear keyboard */

     SetVideoMode(VGA256);     /* Set VGA mode 13h */

     while (!_kbhit())         /* Set random dots to random colors */
          SetPixel((short int)(rand() % 320), (short int)(rand() % 200),
                   (short int)(rand() % 256));

     SetVideoMode(TEXT_MODE);  /* Return to text mode */

     while (_kbhit()) _getch();/* Clear keyboard */
     return 0;                 /* Return without errors */
}

/* SetVideoMode function */
void SetVideoMode(short int mode)
{
     union _REGS regs; /* Create register variables */

     regs.x.ax = mode; /* Set video mode */

     /* Call interrupt to complete the task */
     _int86(0x10, &regs, &regs);
}

/* SetPixel function */
void SetPixel(short int X, short int Y, unsigned char C)
{
     videoMem[Y * 320 + X] = C;
}
